/* This file was generated by plugin '<%= PluginInfo.Name %>' (BDS version <%= PluginInfo.AppVersion %>) */

#include "service_if.h"
#include <stdint.h> <%

var uniqueNames = _.uniq(_.pluck(Services, "ShortName"));
for(var i=0; i<uniqueNames.length; i++) { %>
#include "ble_<%= uniqueNames[i] %>.h" <%
}
%>
<%
_.each(Services, function (service) { %>
static ble_<%= service.ShortName %>_t    m_<%= service.UniqueName %>; <%
}); %>
<%
_.each(Services, function (service) {
    _.each(service.Characteristics, function(characteristic) {
        _.each(characteristic.Fields, function(field) {
            if(field.FormatType() === "uint8_array") { %>
uint8_t m_<%= service.UniqueName %>_<%= characteristic.NormalizedName() %>_initial_value_<%= field.NormalizedName() %>_arr[1]; <%
            }
            else if(field.FormatType() === "regcertdatalist") { %>
uint8_t	m_<%= service.UniqueName %>_<%= characteristic.NormalizedName() %>_initial_value_<%= field.NormalizedName() %>_arr[1]; <%
            }
        });
    });
}); %>
<%
_.each(Services, function (service) { %>

/**@brief Function for handling the <%= service.Name %> events.
 *
 * @details This function will be called for all <%= service.Name %> events which are passed to
 *          the application.
 *
 * @param[in]   p_<%= service.NormalizedName() %>   <%= service.Name %> structure.
 * @param[in]   p_evt   Event received from the <%= service.Name %>.
 */
static void on_<%= service.UniqueName %>_evt(ble_<%= service.ShortName %>_t * p_<%= service.ShortName %>, ble_<%= service.ShortName %>_evt_t * p_evt)
{
    switch (p_evt->evt_type)
    { <%
        _.each(service.Characteristics, function(characteristic) {
            if (characteristic.isNotifySupported() || characteristic.isIndicateSupported()) { %>
        case BLE_<%= service.ShortName.toUpperCase() %>_<%= characteristic.NormalizedName().toUpperCase() %>_EVT_NOTIFICATION_ENABLED:
            break;
        case BLE_<%= service.ShortName.toUpperCase() %>_<%= characteristic.NormalizedName().toUpperCase() %>_EVT_NOTIFICATION_DISABLED:
            break;
        case BLE_<%= service.ShortName.toUpperCase() %>_<%= characteristic.NormalizedName().toUpperCase() %>_EVT_CCCD_WRITE:
            break; <%
            }
            if (characteristic.isWriteSupported() || characteristic.isWriteWithoutResponseSupported()) { %>
        case BLE_<%= service.ShortName.toUpperCase() %>_<%= characteristic.NormalizedName().toUpperCase() %>_EVT_WRITE:    
            break; <%
            }
        }); %>
        default:
            // No implementation needed.
            break;
    }
}
<%
}); %>

/**@brief Function for initializing the Services generated by Bluetooth Developer Studio.
 *
 *
 * @return      NRF_SUCCESS on successful initialization of services, otherwise an error code.
 */
uint32_t bluetooth_init(void)
{
    uint32_t    err_code; <%
    _.each(Services, function (service) { %>
    ble_<%= service.ShortName %>_init_t    <%= service.UniqueName %>_init; <%
    }); %>
    <%
    _.each(Services, function (service) { %>

    // Initialize <%= service.Name %>.
    memset(&<%= service.UniqueName %>_init, 0, sizeof(<%= service.UniqueName %>_init));

    <%= service.UniqueName %>_init.evt_handler = on_<%= service.UniqueName %>_evt; <%
        _.each(service.Characteristics, function(characteristic) {
            if (characteristic.isReadSupported() && !characteristic.isReadMandatory()) { %>
    <%= service.UniqueName %>_init.is_<%= characteristic.NormalizedName() %>_read_supported = true;<%
            }
            if (characteristic.isNotifySupported() && !characteristic.isNotifyMandatory()) { %>
    <%= service.UniqueName %>_init.is_<%= characteristic.NormalizedName()%>_notify_supported = true;<%
            }
            if (characteristic.isIndicateSupported() && !characteristic.isIndicateMandatory()) { %>
    <%= service.UniqueName %>_init.is_<%= characteristic.NormalizedName()%>_indicate_supported = true;<%
            }
            if (characteristic.isWriteSupported() && !characteristic.isWriteMandatory()) { %>
    <%= service.UniqueName %>_init.is_<%= characteristic.NormalizedName() %>_write_supported = true;<%
            }
            if (characteristic.isWriteWithoutResponseSupported() && !characteristic.isWriteWithoutResponseMandatory()) { %>
    <%= service.UniqueName %>_init.is_<%= characteristic.NormalizedName() %>_write_wo_resp_supported = true;<%
            }
            if (characteristic.isReliableWriteSupported() && !characteristic.isReliableWriteMandatory()) { %>
    <%= service.UniqueName %>_init.is_<%= characteristic.NormalizedName() %>_reliable_write_supported = true;<%
            }
            _.each(characteristic.Fields, function(field) {
                if(field.isStruct()) {
                    if(field.Format === "variable") {
                        if(field.FormatType() === "uint8_array") { %>
    <%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>.<%= field.NormalizedName() %>.size = 1;
    <%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>.<%= field.NormalizedName() %>.p_data = m_<%= service.UniqueName %>_<%= characteristic.NormalizedName() %>_initial_value_<%= field.NormalizedName() %>_arr; <%
                        }
                        else if(field.FormatType() === "regcertdatalist") { %>
    <%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>.<%= field.NormalizedName() %>.list_len = 1;
    <%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>.<%= field.NormalizedName() %>.p_list = m_<%= service.UniqueName %>_<%= characteristic.NormalizedName() %>_initial_value_<%= field.NormalizedName() %>_arr; <%
                        }
                        else { %>
    memset(&<%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>,
           0x00,
           sizeof(<%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>));<%
                        }
                    }                        
                    else if(field.Enumerations && field.getEnumerations().length > 0) { %>
    <%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>.<%= field.NormalizedName() %> = <%= field.NormalizedName().toUpperCase() %>_<%= _.first(field.getEnumerations()).NormalizedName().toUpperCase() %>; <%
                    }
                }
                else {
                    if(field.Format === "utf8s") { %>
    ble_srv_ascii_to_utf8(&<%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>, "INITIAL VALUE"); <%
                    }
                    else if(field.FormatType() === "uint8_array") { %>
    <%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>.size = 1;
    <%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>.p_data = m_<%= service.UniqueName %>_<%= characteristic.NormalizedName() %>_initial_value_<%= field.NormalizedName() %>_arr; <%
                    }
                    else if(field.FormatType() === "regcertdatalist") { %>
    <%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>.list_len = 1;
    <%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>.p_list = m_<%= service.UniqueName %>_<%= characteristic.NormalizedName() %>_initial_value_<%= field.NormalizedName() %>_arr; <%
                                        }
                    else { %>
    memset(&<%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>,
           0x00,
           sizeof(<%= service.UniqueName %>_init.ble_<%= service.ShortName %>_<%= characteristic.NormalizedName() %>_initial_value.<%= field.NormalizedName() %>));<%
                    }
                }
            });
        }); %>

    err_code = ble_<%= service.ShortName %>_init(&m_<%= service.UniqueName %>, &<%= service.UniqueName %>_init);
    if (err_code != NRF_SUCCESS)
    {
        return err_code;
    } <%
    }); %>

    return NRF_SUCCESS;
}

/**@brief Function for handling the Application's BLE Stack events.
 *
 * @details Handles all events from the BLE stack of interest to all Bluetooth Developer Studio generated Services.
 *
 * @param[in]   p_ble_evt  Event received from the BLE stack.
 */
void bluetooth_on_ble_evt(ble_evt_t * p_ble_evt)
{ <%
    _.each(Services, function (service) { %>
    ble_<%= service.ShortName %>_on_ble_evt(&m_<%= service.UniqueName %>, p_ble_evt); <%
    }); %>
}
